// TODO: remove on implementation
#![allow(unused_imports)]
#![allow(unused_variables)]
#![allow(dead_code)]

use crate::model::*;
use std::cmp::Ordering;

pub struct Query {
    filters: Vec<QueryFilterModifier>,
}

pub type QueryParserResult = Result<Query, QuerySyntaxError>;
pub enum QuerySyntaxError {
    UnknownFilter,
}

impl Query {
    pub fn parse(input: &[String]) -> QueryParserResult {
        unimplemented!()
    }
}

pub fn search(input: &[Texture], query: &Query) -> Vec<Texture> {
    unimplemented!()
}

enum QueryFilterModifier {
    None(QueryFilter),
    Not(QueryFilter),
}

enum QueryFilter {
    TagName(String),
    InName(String),
    MinResolution(usize),
    BeforeDate(Date),
}

impl QueryFilter {
    fn matches(&self, tex: &Texture) -> bool {
        match self {
            QueryFilter::TagName(tag_name) => {
                tex.tags.iter().find(|tag| tag == &tag_name).is_some()
            }
            QueryFilter::InName(name_part) => tex.name.contains(name_part),
            QueryFilter::MinResolution(minimum) => {
                let resolution = std::cmp::min(tex.resolution.0, tex.resolution.1);
                &resolution >= minimum
            }
            QueryFilter::BeforeDate(date) => &tex.added_on < date,
        }
    }
}
